*************************************
*	Tomi BIS   ver.1.0 -ROM	*
*	       10.10.92 -  7.11.93 *
* COPYRIGHT (c)Tomi		*
*************************************

TRAP	MACRO M,F
	DFB 0
	DFB M*32+F
	MEND

	ORG $1000

PARFUN	EPZ 73	;CISLO FUNKCIE-DOCAS
ZP	EPZ 112
*ZP2	 EPZ 4
*PZ	 EPZ 0

DSKCMD	EQU $0302
DSKAUX1	EQU $030A
DSKAUX2	EQU $030B


FUNTAB	DFW INIT 	; 0
	DFW VERZIA	; 1
	DFW DISK 	; 2
	DFW SPEED	; 3
	DFW RECEIVE	; 4
	DFW SEND 	; 5
	DFW RCVD 	; 6
	DFW SVD		; 7
	DFW LODIN	; 8
	DFW ISDIS	; 9
	DFW WDIS 	;10
	DFW WDRV 	;11
	DFW GEDIN	;12
	DFW PUDIN	;13
	DFW COMMAND	;14
	DFW DCOMAND	;15
	DFW IDD		;16
	DFW UDD		;17
	DFW FORDSK	;18
	DFW VOID 	;19
	DFW VOID 	;20
	DFW VOID 	;21
	DFW VOID 	;22
	DFW VOID 	;23
	DFW VOID 	;24
	DFW VOID 	;25
	DFW VOID 	;26
	DFW VOID 	;27
	DFW VOID 	;28
	DFW VOID 	;29
	DFW VOID 	;30
	DFW VOID 	;31

BASINI	LDY #LINKTAB&255
	LDA #LINKTAB>>8
	SEC
	TRAP 6,28
	LDY #1
	CLC
	RTS

LINKTAB	DFB 0,0,0,0,0,0,0,0,0,0,0,0
	JMP INIBIS
	DFB 0
	DFW $0500,0

INIBIS	LDA #$87
	LDX #BIS&255
	LDY #BIS>>8
	TRAP 6,0
	LDA #$C8
	LDX #ADISIN&255
	LDY #ADISIN>>8
	TRAP 6,0
	CLC
	RTS

BIS	PHP
	PHA
	TXA
	PHA
	LDA PARFUN
	ASL	;*2
	TAX
	LDA FUNTAB,X
	STA ZP
	LDA FUNTAB+1,X
	STA ZP+1
	LDA 54017
	STA PROM
	LDA #254
	STA 54017
	PLA
	TAX
	PLA
	PLP
	JSR BIS1
	PHP
	PHA
	LDA PROM
	STA 54017
	PLA
	PLP
	RTS
BIS1	JMP (ZP)

ADISIN	LDA 54017
	STA DIRPOM
	LDA #255
	STA 54017
	JSR BDISIN
	PHP
	PHA
	LDA DIRPOM
	STA 54017
	PLA
	PLP
	RTS
DIRPOM	DFB 255

BDISIN	LDA #$31
	STA $0300
	LDX $0246
	LDA $0302
	AND #$7F ;NO INVERZ
	CMP #$21 ;FORMAT
	BEQ DSKIN1
	CMP #$22 ;FORMAT AT1050
	BEQ DSKIN1
	LDX #$07
DSKIN1	STX $0306
	LDX #$40
	LDA $0302
	AND #$7F ;NO INVERZ
	CMP #'P' ;PUT
	BEQ DSKIN2
	CMP #'O'
	BEQ DSKIN2
	CMP #'W' ;WRITE
	BNE DSKIN3
DSKIN2	LDX #$80
DSKIN3	CMP #'N'
	BEQ DSKIN33
	CMP #'O'
	BEQ DSKIN33
	CMP #'S' ;STATUS
	BNE DSKIN4
	LDA #$EA
	STA $0304
	LDA #$02
	STA $0305
	LDY #$04
	LDA #$00
	BEQ DSKIN5
DSKIN33	LDY #12	;DLZKA 12 PRI O,N
	LDA #0
	BEQ DSKIN5
DSKIN4	LDY $02D5
	LDA $02D6
DSKIN5	STX $0303
	STY $0308
	STA $0309
	LDA $0302
	BMI DSKIN55
	JSR $E459	;SIO
	JMP DSKIN56
DSKIN55	JSR SIOINT
DSKIN56	BPL DSKIN6
	RTS
DSKIN6	LDA $0302
	AND #$7F ;NO INV.
	CMP #$22
	BNE DSKIN66
	LDA #$21
DSKIN66	STA $0302
	JMP $C6FF	;CONTINUE

SIOINT	LDA #$01
	STA $0042
	LDA $0301
	PHA
	JSR SIO
	JMP $C95E	;CONTINUE

SIO	TSX
	STX $0318
	LDA #$01
	STA $42
	LDA #$00
	STA $030F
	LDA #$00 ;1 POKUS
	STA $02BD
	LDA #$0D ;13 POKUSOV O KOM.
	STA $029C
SIO0	LDA #$28
	STA $D204
	LDA #$00
	STA $D206
	CLC
	LDA $0300
	ADC $0301
	ADC #$FF
	STA $023A
	LDA $0302
	STA $023B
	LDA $030A
	STA $023C
	LDA $030B
	STA $023D
	CLC
	LDA #$3A
	STA $32
	ADC #$4
	STA $34
	LDA #$02
	STA $33
	STA $35
	LDA #$34
	STA $D303
	JSR $ECAF
	LDA $023F
	BNE SIO1
	TYA
	BNE SIO2
SIO1	DEC $029C
	BPL SIO0
	JMP $EA22
SIO2	LDA #$10 ;SPEED= 38908 Bd
	STA $D204
	LDA #$00
	STA $D206
	JMP $E9E1	;CONTINUE

SETRYCH	LDA RYCHL
	ASL	;*2
	TAY
	LDA TRYCH,Y
	STA $D204	;AUDIFREQ3
	LDA TRYCH+1,Y
	STA $D206	;AUDIFREQ4
	RTS

RECEIVE	LDA 54017
	STA RSPOM
	LDA #255
	STA 54017
	JSR SETRYCH	;IONS(50-53)
	JSR $EC9A	;SETIMEOUT
	JSR $EDE2	;SETTIM1V
	LDA #0
	STA $30F ;CASFLAG
	JSR $EAFD	;RECEIVE
	JSR $EC84	;SENDDIS
	PHP
	PHA
	LDA RSPOM
	STA 54017
	PLA
	PLP
	RTS
SEND	LDA 54017
	STA RSPOM
	LDA #255
	STA 54017
	JSR SETRYCH	;IONS(50-53)
	JSR $EA88	;SEND
	PHP
	PHA
	LDA RSPOM
	STA 54017
	PLA
	PLP
	RTS
RSPOM	DFB 255

PROM	DFB 255
*BUAC	 DFB 0
*BUXR	 DFB 0
*BUYR	 DFB 0

AADISI	DFW ADISIN
*-------------------------*
	LDA #$00 ;SERIAL NUMBER
	LDX #$00 ; A+X*Y
	LDY #$00
	RTS	; NIC

VERZIA	LDA #%00001000	;VERZIA
	RTS

BUF	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0

* --TABULKY-- *

TMECH	DFW $8080,$8080
	DFW $8080,$8080	;O MECH.
TDISK	DFW $8080,$8080
	DFW $8080,$8080	;O DISKOCH
RYCHL	DFB 0	;RYCHLOST
*
POM	DFB 0
POM2	DFB 0
POM1	DFB 0
IPOM	DFB 0
CM	DFB 0
CD	DFB 0

PPOM8	DFB 0,0,0,0,0,0,0,0

NBUF	DFB 40,0,0,18,0,0,0,128,1,65,0,0

BTDAT	DFB 0,0,0,128
	DFW $50750,0,0,0,0,0,0,0,0,0

TDSKINF	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0
*----------------------------------------*
	ORG $F600

* ---INTERNAL FUNCTION--- *
COMD	LDY CD
	LDA TDISK,Y
	BMI COME
	AND #$07
	STA CM
	STA 769	;CISLO MECHANIKY
	TAY
	LDA TMECH,Y
	BMI COME2
	AND #$07
	CMP CD
	BEQ COMR
	LDA CD
	LDX CM
	LDY #EBADDSK
	RTS
COME	LDY #EFREDSK
	RTS
COME2	LDY #ENODRV
	RTS
COMR	LDY #1
	RTS

KRAT32	ASL
	ASL
	ASL
	ASL
	ASL	;*32
	TAY	;Y=A*32
	RTS

DINTERF	OUT
*	LDA $301
*	CMP #7
*	BNE DSKINTE
*	JMP RINTERF
DSKINTE	JMP (AADISI)

* -FUNKCIE- *
DISK	AND #$07
	STA CD
	LDY #1
	RTS
SPEED	LDY RYCHL
	STY POM
	STA RYCHL
	JSR SETRYCH
	LDA POM
	LDY #1
	RTS

COMMAND	JSR COMD ;SOFT TEST DSK V DRV
	BMI COMME
	JMP DINTERF	;DISKINTERF
COMME	RTS

DCOMAND	JSR COMD
	BMI COMME
	LDA CD
	JSR KRAT32
	LDA TDSKINF,Y	;DL. SEK
	STA 725
	LDA TDSKINF+1,Y
	STA 726
	LDA 779
	BNE DCM1
	LDA 778
	CMP #4
	BCS DCM1
NSGET	LDA #128
	STA 725
	LDA #0
	STA 726
DCM1	JMP DINTERF	;DISKINTERF

RCVD	LDY #0
RCVD1	LDA TDISK,Y
	BMI RCVD2
	INY
	CPY #8
	BCC RCVD1
	LDY #EBZYDSK
	RTS
RCVD2	STY POM
	LDY #7
	TYA
RCVDC	STA PPOM8,Y
	DEY
	BPL RCVDC
	LDY #0
RCVD3	LDA TDISK,Y
	BMI RCVD4
	AND #$07
	TAX
	INC PPOM8,X
RCVD4	INY
	CPY #8
	BCC RCVD3
	LDY #0
RCVD5	LDA TMECH,Y
	BPL RCVD6
	LDA #$FF
	STA PPOM8,Y
RCVD6	INY
	CPY #8
	BCC RCVD5
	LDX #$FF
	STX POM2
	LDY #0
RCVD7	LDA PPOM8,Y
	CMP POM2
	BCS RCVD8
	STA POM2
	TYA
	TAX
RCVD8	INY
	CPY #8
	BCC RCVD7
	CPX #$FF
	BEQ RCVDE
	LDA POM
	LDY #1
	RTS
RCVDE	LDY #ENODRV
	RTS

SVD	AND #$07
	TAY
	LDA #$80
	STA TDISK,Y
	LDY #1
	RTS

LODIN	STA POM	;CISLO DISKU
	STX POM2 ;CISLO MECH.
	TAY
	LDA TDISK,Y
	BMI LODIN1
	LDY #EBZYDSK
	RTS
LODIN1	TXA
	TAY
	LDA TMECH,Y
	BPL LODIN2
	LDY #ENODRV
LODINE	RTS
LODIN2	LDA POM2
	STA 769	;CISLO MECH.
	LDA #'R'
	STA DSKCMD
	LDX #1
	STX DSKAUX1
	DEX
	STX DSKAUX2
	LDA #BUF&255
	STA 772
	LDA #BUF>>8
	STA 773
	JSR NSGET
	BMI LODINE
FORLOD	LDA POM
	JSR KRAT32
	LDX #9
LODIN3	LDA BUF,X
	STA TDSKINF,Y
	INY
	INX
	CPX #41
	BCC LODIN3
	LDA POM2
	LDY POM
	STA TDISK,Y
	LDY POM2
	LDA POM
	STA TMECH,Y
	LDY #1
	RTS

ISDIS	LDY CD
	LDA TDISK,Y
	STA CM
	STA 769	;CISLO MECH.
	LDA #'R'
	STA DSKCMD
	LDX #1
	STX DSKAUX1
	DEX
	STX DSKAUX2
	LDA #BUF&255
	STA 772
	LDA #BUF>>8
	STA 773
	JSR NSGET
	BMI ISDISE
	LDA CD
	JSR KRAT32
	LDX #9
ISDIS1	LDA BUF,X
	CMP TDSKINF,Y
	BNE ISDISN
	INY
	INX
	CPX #41
	BCC ISDIS1
	LDA CD
	LDY CM
	STA TMECH,Y
	LDY #1
	RTS
ISDISN	LDY #EBADDSK
ISDISE	RTS

WDIS	TAY
	LDA TMECH,Y
	BMI WDIS1
	AND #$07
	LDY #1
	RTS
WDIS1	LDY #ENODRV
	RTS

WDRV	TAY
	LDA TDISK,Y
	BMI WDRV1
	AND #$07
	LDY #1
	RTS
WDRV1	LDY #EFREDSK
	RTS

GEDIN	STX ZP
	STY ZP+1
	LDY CD
	LDA TDISK,Y
	BMI GEDIN2
	LDA CD
	JSR KRAT32
	TYA
	TAX
	LDY #0
GEDIN1	LDA TDSKINF,X
	STA (ZP),Y
	INX
	INY
	CPY #32
	BCC GEDIN1
	LDY #1
	RTS
GEDIN2	LDY #EFREDSK
	RTS

PUDIN	CMP #$12
	BNE PUDIN3
	STX ZP
	STY ZP+1
	LDY CD
	LDA TDISK,Y
	BMI PUDIN2
	LDA CD
	JSR KRAT32
	TYA
	TAX
	LDY #0
PUDIN1	LDA (ZP),Y
	STA TDSKINF,X
	INX
	INY
	CPY #32
	BCC PUDIN1
	LDY #1
	RTS
PUDIN2	LDY #EFREDSK
	RTS
PUDIN3	LDY #EBNF
	RTS

IDD	STA POM
	STA $0301	;CM
	LDA #'S'
	STA 770
	JSR DINTERF
	BMI IDD1
	LDY POM
	LDA #0
	STA TMECH,Y
	LDY #1
	RTS
IDD1	STY POM2
	LDY POM
	LDA #$80
	STA TMECH,Y
	LDY POM2
	RTS

UDD	TAY
	LDA #$80
	STA TMECH,Y
	LDY #1
	RTS

FORDSK	CPY #$04
	BCC FORDS0
	JMP VOID
FORDS0	STY POM1
	STA POM	;CISLO DISKU
	STX POM2 ;CISLO MECH.
	TAY
	LDA TDISK,Y
	BMI FORDS1
	LDY #EBZYDSK
	RTS
FORDS1	TXA
	TAY
	LDA TMECH,Y
	BPL FORDS2
	LDY #ENODRV
FORDSE	RTS
FORDS2	LDA POM2
	STA 769	;CISLO MECH.
	LDY #720&255
	STY PPOM8+2
	LDY #720>>8
	STY PPOM8+3
	LDA #0
	STA NBUF+4
	LDY #'!'
	LDX #18
	LDA POM1
	CMP #3
	BNE FORD22
	LDY #1440&255
	STY PPOM8+2
	LDY #1440&255
	STY PPOM8+3
	LDY #1
	STY NBUF+4
	LDY #'!'
FORD22	CMP #1
	BNE FORDS3
	LDY #1040&255
	STY PPOM8+2
	LDY #1040&255
	STY PPOM8+3
	LDY #'"'
	LDX #26
FORDS3	STX NBUF+3
	LDX #128
	LSR
	AND #$01
	STA NBUF+6
	STA PPOM8+1
	ASL		;?
	ASL		;?
	STA NBUF+5	;?
	BEQ FORDS4
	LDX #0
FORDS4	STX NBUF+7
	STX PPOM8
	STY POM1
	LDA #'O'
	STA DSKCMD
	LDX #0
	STX DSKAUX1
	STX DSKAUX2
	LDA #NBUF&255
	STA 772
	LDA #NBUF>>8
	STA 773
	JSR DINTERF	;DISKINTERF
FORDSF	BMI FORDSE
	LDA #'S'
	STA DSKCMD
	LDA #BUF&255
	STA 772
	LDA #BUF>>8
	STA 773
	JSR NSGET
	BMI FORDSF
	LDA POM1
	STA DSKCMD
	LDA #BUF&255
	STA 772
	LDA #BUF>>8
	STA 773
	LDA PPOM8
	STA 725
	LDA PPOM8+1
	STA 726
	JSR DINTERF
FORDSFE	BMI FORDSF
	LDA $0308
	STA POM1
	LDA #1
	LDX #BUF&255
	LDY #BUF>>8
	TRAP 6,13
	BMI FORDSFE
	STA PPOM8+7
	LDX #127
	LDA #0
FORDS5	STA BUF,X
	DEX
	BPL FORDS5
	LDX #24
FORDS6	LDA BTDAT,X
	STA BUF,X
	DEX
	BPL FORDS6
	LDX #3
FORDS7	LDA PPOM8,X
	STA BUF+9,X
	LDA 53770	;RND
	STA BUF+23,X
	DEX
	BPL FORDS7
	LDA #%01100000
	STA BUF+23
	LDA #'W'
	STA DSKCMD
	LDX #1
	STX DSKAUX1
	DEX
	STX DSKAUX2
	LDA #BUF&255
	STA 772
	LDA #BUF>>8
	STA 773
	JSR NSGET
	BPL FORDSFO
	STY PPOM8+6
	LDA PPOM8+7
	TRAP 6,14
	LDY PPOM8+6
	BMI FORDSFE	;JMP
FORDSFO	JSR FORLOD	;LODIN-KON.
	LDA PPOM8+7
	TRAP 6,14
	LDA #BUF&255
	LDX #BUF>>8
	LDY POM1
	STY $0308
	LDY #0
	STY $0309
	INY
	RTS

INIT	LDA #0
	STA IPOM
INIT1	JSR IDD
	INC IPOM
	LDA IPOM
	CMP #8
	BCC INIT1
	LDA #$80
	LDY #7
INIT2	STA TDISK,Y
	DEY
	BPL INIT2
	LDA #0
	STA RYCHL
	LDA #$48
	TRAP 6,0
	BMI INIT3
	STA AADISI
	STX AADISI+1
	LDY #1
INIT3	RTS

VOID	LDY #EBNF
	RTS

* -ERRORS- *
ENODRV	EQU 200
EBADDSK	EQU 201
*EZLIDSK  EQU 202 		;??????
EFREDSK	EQU 203
EBZYDSK	EQU 204
EBNF	EQU 205

*  TABULKA PRENOSOVYCH RYCHLOSTI  *

TRYCH	DFW $0028	;0:19200 B
	DFW $0056	;1: 9600 B
	DFW $00B3	;2: 4800 B
	DFW $00F2	;3: 3600 B
	DFW $016E	;4: 2400 B
	DFW $01B8	;5: 2000 B
	DFW $01EA	;6: 1800 B
	DFW $02E3	;7: 1200 B
	DFW $05CC	;8:  600 B
	DFW $0BA0	;9:  300 B
	DFW $1173	;10: 200 B
	DFW $1747	;11: 150 B
	DFW $1A0F	;12: 134 B
	DFW $1FC0	;13: 110 B
	DFW $2E95	;14:  75 B
	DFW $45E3	;15:  50 B
	DFW $0016	;16:31250 B
	DFW $006C	;17:7812 B

	ORG 738	;INIT
	DFW BASINI	;INIC.TRAP

