*************************************
*	Tomi BIS INTERN  ver.1.0 -R*
*	       10.10.92 -  7.12.93 *
* COPYRIGHT (c)Tomi		*
*************************************

	ORG $0800

PARFUN	EPZ 73	;CISLO FUNKCIE-DOCAS
ZP	EPZ 112
ZP2	EPZ 4
MAXKEY	EPZ 64	;DLZKA KLAVES.BUFERU

SINIT	JMP BASINI	;INIC.TRAPS
	LDA #0		;BASIC CALL
	STA 213
	PLA
	STA 212
	STA ZP+1
	SEC
	SBC #2
	BCC BUSRE
	STA ZP+1
	PLA
	PLA
	ASL
	ASL
	ASL
	ASL
	ASL	;/32
	STA ZP
	PLA
	PLA
	AND #$1F
	ORA ZP
	STA BUSR
	LDA #0
	STA BUAC
	STA BUXR
	STA BUYR
	LDA ZP+1
	SEC
	SBC #1
	STA ZP+1
	BCC BUSRS
	PLA
	PLA
	STA BUAC
	LDA ZP+1
	SEC
	SBC #1
	STA ZP+1
	BCC BUSRS
	PLA
	PLA
	STA BUXR
	LDA ZP+1
	SEC
	SBC #1
	STA ZP+1
	BCC BUSRS
	PLA
	PLA
	STA BUYR
	LDA ZP+1
	BNE BUSRE
BUSRS	LDA BUAC
	LDX BUXR
	LDY BUYR
	BRK	;TRAP
BUSR	DFB 0
	STA 212
	STX 213
	STY 195
	RTS
BUSRE	LDA ZP+1
	BEQ BUSRF
	PLA
	PLA
	DEC ZP+1
	JMP BUSRE
BUSRF	RTS

BASINI	LDA 54017
	STA ROMP
	LDA #254
	STA 54017
	LDA #0
	TAY
BASIN1	STA $FF00,Y
	INY
	CPY #$C0
	BCC BASIN1
	LDA #$FF
	STA $FF83
	LDY #16
	LDA #$0F
BASIN2	STA $FF00,Y
	INY
	CPY #24
	BCC BASIN2
	LDA #$08
	STA $FF20
	LDA #$09
	STA $FF21
	LDA #$0A
	STA $FF22
	LDA #$0B
	STA $FF23
	LDA #$01
	LDY #41
BASIN3	STA $FF00,Y
	INY
	CPY #64
	BCC BASIN3
	LDA ROMP
	STA 54017
	LDA 9
	STA P9
	LDA #0
	STA 9
	LDY #LINKTAB&255
	LDA #LINKTAB>>8
	SEC
	JSR $E48C
	LDA P10
	STA 10
	LDA P11
	STA 11
	LDA #$80
	STA SW
	LDA #0
	STA STAT
	LDA #$50
	STA PAL
	LDA #4*60
	STA MSLP
	LDA #25
	STA CBL
	CLC
	RTS

P6	DFB 0
P9	DFB 0
P10	DFB 0
P11	DFB 0

LINKTAB	DFB 0,0,0,0,0,0,0,0,0,0,0,0
	JMP INIBISI
	DFB 0
	DFW 0,0

INIBISI	LDA $0206
	STA ADRBRK
	LDA $0207
	STA ADRBRK+1
	LDA #IBRK&255
	STA $0206
	LDA #IBRK>>8
	STA $0207
	LDA #KEYDEF&255
	STA 121
	LDA #KEYDEF>>8
	STA 122
	LDA 20
INITW	CMP 20
	BEQ INITW
	LDA #VBI&255
	STA $0222
	LDA #VBI>>8
	STA $0223
	LDA #CPIRQQ&255
	STA 520
	LDA #CPIRQQ>>8
	STA 521
	LDA #DLIE&255
	STA $0200
	LDA #DLIE>>8
	STA $0201
	LDA 10
	STA P10
	LDA 11
	STA P11
	LDA #DOS&255
	STA 10
	LDA #DOS>>8
	STA 11
	LDA 6
	STA P6
	LDA #0
	STA 6
	LDA #0
	STA 743
	LDA #$10 ;???
	STA 744
	CLC
	RTS

DOS	LDA P10
	STA 10
	LDA P11
	STA 11
	LDA P9
	AND #$02
	BEQ DOS1
	JSR $C6A0	;(2)
DOS1	LDA P9
	AND #$01
	BEQ DOS2
	JSR $C63B	;(12)
DOS2	LDA P6
	BEQ DOS3
	LDA $BFFD
	AND #$04
	BEQ DOS3
	JMP ($BFFA)
DOS3	JMP (10)

IBRK	CLD
	STX BUXR
	STY BUYR
	PLA
	STA BUAC
	PLA
	STA PARFUN
	PLA
	STA ZP
	PLA
	STA ZP+1
	LDA ZP
	BNE IBRK1
	DEC ZP+1
IBRK1	DEC ZP
	LDA ZP+1
	PHA
	LDA ZP
	PHA
	LDA PARFUN
	PHA	;PRIZNAKY
	LDY #0
	LDA (ZP),Y
	TAY
	LSR
	LSR
	LSR
	LSR	;/16
	AND #$0E
	TAX
	TYA
	AND #$1F
	STA PARFUN
	LDA TTRAP,X
	STA ZP
	LDA TTRAP+1,X
	STA ZP+1
	LDY BUYR
	LDX BUXR
	LDA BUAC
	PLP
	CLD
	JMP (ZP)

SBRK	PHP
	DFB 76
ADRBRK	DFW $C0CD

TTRAP	DFW SBRK,SBRK,SBRK,SBRK
	DFW SBRK,SBRK,INTERN,SBRK

TUSVEC	DFW CREMEM,CLOMEM,CHMEM,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0

TMES	DFB 0,31,28,31,30,31,30
	DFB 31,31,30,31,30,31

BUAC	DFB 0
BUXR	DFB 0
BUYR	DFB 0

INTERN	PHP
	PHA
	TXA
	PHA
	LDA PARFUN
	ASL	;*2
	TAX
	LDA INTFTAB,X
	STA ZP
	LDA INTFTAB+1,X
	STA ZP+1
	CPX #$20
	BCS INTERN1
	LDA 54017
	STA ROMP
	LDA #254
	STA 54017
	PLA
	TAX
	PLA
	PLP
	JSR INTERN2
	PHP
	PHA
	LDA ROMP
	STA 54017
	PLA
	PLP
	RTS
INTERN1	LDA 54017
	STA ROMP
	LDA #255
	STA 54017
	PLA
	TAX
	PLA
	PLP
	JSR INTERN2
	PHP
	PHA
	LDA ROMP
	STA 54017
	PLA
	PLP
	RTS
INTERN2	JMP (ZP)

INTFTAB	DFW TRAPVCT	; 0
	DFW VERZIA	; 1
	DFW SETTIME	; 2
	DFW SETDATE	; 3
	DFW REDTIME	; 4
	DFW REDDATE	; 5
	DFW SETUP	; 6
	DFW WAITSLP	; 7
	DFW SFNADR	; 8
	DFW CHKEY	; 9
	DFW PUTKEYS	;10
	DFW ASCTSCN	;11
	DFW WAITBL	;12
	DFW QCREMEM	 ;13
	DFW QCLOMEM	 ;14
	DFW QCHMEM	 ;15
	DFW $E456	;16-CIO
	DFW $E459	;17-SIO
	DFW $E45C	;18
	DFW $E46B	;19
	DFW $E46E	;20
	DFW $E471	;21
	DFW $E474	;22
	DFW $E477	;23
	DFW $E47A	;24
	DFW $E47D	;25
	DFW $E486	;26
	DFW $E489	;27
	DFW $E48C	;28
	DFW GETKEY	;29
	DFW $F2B0	;30
	DFW $C642	;31

GETKEY	LDA SW
	AND #$10
	BNE GETKEY1
	JMP $F2F8
GETKEY1	JMP $F302

*-------------------------*
	LDA #$00 ;SERIAL NUMBER
	LDX #$00 ; A+X*Y
	LDY #$00
	JMP VOID ; NIC

VERZIA	LDA #%00001000	;VERZIA
	LDX #0
	LDY #1
	RTS

* --TABULKY-- *
CLK	DFB 0
CLKS	DFB 0
CLKM	DFB 0
CLKH	DFB 0
DTMD	DFB 0
DTMM	DFB 0
DTMR	DFB 0
SLP	DFB 0
STAT	DFB 0
SW	DFB 0
PAL	DFB 50
MSLP	DFB 5
CBL	DFB 0
PBL	DFB 0
KBP	DFB 0
KBUF	DFW 0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0	;?
	DFW 0,0,0,0,0,0,0,0	;?
CHMPOM	DFB 0
CHMDL	DFB 0
POM	DFB 0

VOID	LDY #0
	RTS

ROMP	DFB 255

* -------HARDWARE--------- *
NMIVKT	BIT $D40F
	BPL NMIVKT1
	JMP ($0200)
NMIVKT1	CLD
	PHA
	TXA
	PHA
	TYA
	PHA
	STA $D40F
	JMP ($0222)

IRQVKT	CLD
	STA $028C
	PLA
	PHA
	AND #$10
	BEQ IRQVKT1
	LDA $028C
	PHA
	JMP ($0206)
IRQVKT1	LDA $028C
	RTI

VBI	INC $4D
	INC 20
	BNE VBI1
	INC 19
	BNE VBI1
	INC 18
VBI1	LDX #0
	LDA $4D
	CMP PAL
	BCC VBI2
	STX $4D
	LDA STAT 	;SLEEP
	BMI VBI2
	LDA SW
	BPL VBI2
	INC SLP
	LDA SLP
	CMP MSLP
	BCC VBI2
	STX SLP
	LDA 559
	BEQ VBI2
	STA $02DD
	STX 559
	LDA STAT
	ORA #$80
	STA STAT
VBI2	INC CLK
	LDA CLK
	CMP PAL
	BCC VBI3
	STX CLK
	INC CLKS
	LDA CLKS
	CMP #60
	BCC VBI3
	STX CLKS
	INC CLKM
	LDA CLKM
	CMP #60
	BCC VBI3
	STX CLKM
	INC CLKH
	LDA CLKH
	CMP #24
	BCC VBI3
	STX CLKH
	LDA STAT
	ORA #$01
	STA STAT
VBI3	LDX #0
	JSR $C255
	BNE VBI4
	JSR $C24F
VBI4	LDA $42	;CRITICIO
	BNE VBI5
	LDA 54017
	AND #$01
	BEQ VBI5 ;KONIEC AK ROM OFF
	TSX
	LDA $0104,X
	AND #$04
	BEQ VBI6
VBI5	PLA	   ;EXITVBL
	TAY
	PLA
	TAX
	PLA
DLIE	RTI
VBI6	LDA STAT
	AND #$01
	BEQ VBI7
	LDA STAT
	AND #$FE
	STA STAT
	LDX #1
	LDY DTMM
	LDA DTMD
	INC DTMD
	CMP TMES,Y
	BCC VBI7
	STX DTMD
	INC DTMM
	LDA DTMM
	CMP #13
	BCC VBI7
	STX DTMM
	INC DTMR
VBI7	LDA 9
	BEQ VBI8
	STA P9
	LDA #0
	STA 9
VBI8	LDA $0206
	CMP #IBRK&255
	BNE VBI9
	LDA $0207
	CMP #IBRK>>8
	BNE VBI9
VBI10	LDA SW
	AND #$10
	BEQ VBI11
	LDA 764
	CMP #255
	BNE VBI11
	LDA KBP
	BEQ VBI11
	DEC KBP
	LDX KBP
	LDA KBUF,X
	STA $02FC
	STA $02F2
	LDA #3
	STA $02F1
VBI11	LDA SW
	AND #$08
	BEQ VBI12
	DEC PBL
	BNE VBI12
	LDA CBL
	STA PBL
	LDA 755
	EOR #$02
	STA 755
VBI12	JMP $C123	;CONTINUE
VBI9	LDA $0206
	STA ADRBRK
	LDA $0207
	STA ADRBRK+1
	LDA #IBRK&255
	STA $0206
	LDA #IBRK>>8
	STA $0207
	JMP VBI10

CPIRQQ	PHA
	TYA
	PHA
	LDX $D301
	LDA $D209
	CMP $02F2
	BNE CPIR1
	LDY $02F1
	BNE CPIR2
CPIR1	TAY
	LDA (121),Y
	CMP #$E1 ;CTRL-F1
	BNE CPIR3
	TAY
	LDA $026D
	EOR #$FF
	STA $026D
	BNE CPIR4
	TXA
	ORA #$04
	BNE CPIR5
CPIR4	TXA
	AND #$FB
CPIR5	TAX
	TYA
	BCS CPIR9
CPIR3	LDY $026D
	BNE CPIR7
	TAY
	CMP #$E3 ;CTRL-1
	BNE CPIR8
	LDA $02FF
	EOR #$FF
	STA $02FF
	BCS CPIR9
CPIR8	LDA $D209
	AND #$3F
	CMP #$11 ;HELP
	BNE CPIR10
	LDA $D209
	STA $02DC
	BEQ CPIR9	;VZDY
CPIR12	LDA SW
	AND #$10
	BNE CPIRB1
	LDA $D209
	STA $02FC
	STA $02F2
CPIR9	TXA
	TAY
	LDA STAT
	AND #$7F
	STA STAT
	LDA #0
	STA SLP
	JMP $FC6D
CPIR2	TXA
	TAY
	JMP $FC76
CPIR7	TXA
	TAY
	JMP $FC87
CPIR10	TYA
	CMP #$E2 ;CTRL-F2
	BEQ CPIR11
	CMP #$E4
	BNE CPIR14
	LDA $02F4
	LDY $026B
	STA $026B
	STY $02F4
	CPY #$CC
	BEQ CPIR13
	TXA
	ORA #$08
	TAX
	BNE CPIR9
CPIR13	TXA
	AND #$F7
	TAX
	JMP CPIR9
CPIR11	LDA $022F
	BEQ CPIR7
	STA $02DD
	LDA #0
	STA $022F
	BEQ CPIR7
CPIR14	AND #$F0
	CMP #$A0
	BNE CPIR12
	TYA
	AND #$0F
	ASL	;*2
	TAY
	LDA TABFN,Y
	STA ZP
	LDA TABFN+1,Y
	STA ZP+1
	TXA
	PHA
	JSR CPIR15
	PLA
	TAX
	JMP CPIR9
CPIR15	JMP (ZP)
CPIRB1	LDA KBP
	CMP #MAXKEY-2	;30
	BCS CPIR9
	LDY KBP
CPIRB2	LDA KBUF,Y
	STA KBUF+1,Y
	DEY
	BPL CPIRB2
	LDA $D209
	STA KBUF
	INC KBP
	JMP CPIR9

CAD	BRK
	DFB 215	;COLDSTART
	RTS

FNV	RTS

* -------TABULKA KLAVES---------*

KEYDEF	DFB $6C,$6A,$3B,$8A
	DFB $8B,$6B,$2B,$2A
	DFB $6F,$80,$70,$75
	DFB $9B,$69,$2D,$3D
	DFB $76,$80,$63,$8C
	DFB $8D,$62,$78,$7A
	DFB $34,$80,$33,$36
	DFB $1B,$35,$32,$31
	DFB $2C,$20,$2E,$6E
	DFB $80,$6D,$2F,$81
	DFB $72,$80,$65,$79
	DFB $7F,$74,$77,$71
	DFB $39,$80,$30,$37
	DFB $7E,$38,$3C,$3E
	DFB $66,$68,$64,$80
	DFB $82,$67,$73,$61

	DFB $4C,$4A,$3A,$8A
	DFB $8B,$4B,$5C,$5E
	DFB $4F,$80,$50,$55
	DFB $9B,$49,$5F,$7C
	DFB $56,$80,$43,$8C
	DFB $8D,$42,$58,$5A
	DFB $24,$80,$23,$26
	DFB $1B,$25,$22,$21
	DFB $5B,$20,$5D,$4E
	DFB $80,$4D,$3F,$81
	DFB $52,$80,$45,$59
	DFB $9F,$54,$57,$51
	DFB $28,$80,$29,$27
	DFB $9C,$40,$7D,$9D
	DFB $46,$48,$44,$80
	DFB $83,$47,$53,$41

	DFB $0C,$0A,$7B,$E1
	DFB $E2,$0B,$1E,$1F
	DFB $0F,$80,$10,$15
	DFB $9B,$09,$1C,$1D
	DFB $16,$80,$03,$89
	DFB $E4,$02,$18,$1A
	DFB $80,$80,$85,$80
	DFB $1B,$80,$FD,$E3	;CTRL 1
	DFB $00,$20,$60,$0E
	DFB $80,$0D,$80,$81
	DFB $12,$80,$05,$19
	DFB $9E,$14,$17,$11
	DFB $80,$80,$80,$80
	DFB $FE,$80,$7D,$FF
	DFB $06,$08,$04,$80
	DFB $84,$07,$13,$01

	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $A4,$80,$A3,$A6
	DFB $A0,$A5,$A2,$A1
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80
	DFB $A9,$80,$AA,$A7
	DFB $AD,$A8,$AB,$AC
	DFB $80,$80,$80,$80
	DFB $80,$80,$80,$80

TABFN	DFW FNV,FNV,FNV,FNV
	DFW FNV,FNV,FNV,FNV
	DFW FNV,FNV,FNV,FNV
	DFW FNV,CAD,FNV,FNV

* ---- ROM PART ---- *

	ORG $FB00

SETUP	CPX #$80
	BCC REUP
	STA SW
	TAY
	LDX #50
	AND #$01
	BEQ SETUP1
	LDX #60
SETUP1	STX PAL
	LDA #'z'
	STA KEYDEF+23
	LDA #'y'
	STA KEYDEF+43
	LDA #'Z'
	STA KEYDEF+87
	LDA #'Y'
	STA KEYDEF+107
	TYA
	AND #$20
	BEQ SETUP2
	LDA #'y'
	STA KEYDEF+23
	LDA #'z'
	STA KEYDEF+43
	LDA #'Y'
	STA KEYDEF+87
	LDA #'Z'
	STA KEYDEF+107
SETUP2	LDA #$80
	STA KEYDEF+152
	STA KEYDEF+157
	STA KEYDEF+155
	STA KEYDEF+179
	STA KEYDEF+181
	STA KEYDEF+176
	STA KEYDEF+178
	TYA
	AND #$40
	BEQ SETUP3
	LDA #$89
	STA KEYDEF+152
	LDA #$E1
	STA KEYDEF+157
	LDA #$E2
	STA KEYDEF+155
	LDA #$8E
	STA KEYDEF+179
	LDA #$8F
	STA KEYDEF+181
	LDA #$90
	STA KEYDEF+176
	LDA #$91
	STA KEYDEF+178
SETUP3	LDY #1
	RTS
REUP	LDA SW
	LDX #0
	LDY #1
	RTS	

WAITBL	LDY CBL
	STA CBL
	TYA
	LDY #1
	RTS

PUTKEYS	STA ZP
	STX ZP+1
	CPY #0
	BEQ PUTKEY
	TYA
	CLC
	ADC KBP
	CMP #MAXKEY-1	;31
	BCS PUTKEYE
	TAX
	STY PARFUN
	LDY KBP
	STX KBP
PUTKEY1	LDA KBUF,Y
	STA KBUF,X
	DEX
	DEY
	BPL PUTKEY1
	LDX PARFUN
	DEX
	LDY #0
PUTKEY2	LDA (ZP),Y
	STA KBUF,X
	INY
	DEX
	BPL PUTKEY2
	LDY #1
	RTS
PUTKEYE	LDY #146
	RTS
PUTKEY	LDA KBP
	CMP #MAXKEY-2	;30
	BCS PUTKEYE
	LDY KBP
PUTKEY3	LDA KBUF,Y
	STA KBUF+1,Y
	DEY
	BPL PUTKEY3
	LDA ZP
	STA KBUF
	INC KBP
	LDY #1
	RTS

ASCTSCN	STA ZP
	STX ZP+1
	STY PARFUN
	LDA #0
	STA BUYR
ASCTSC1	LDY PARFUN
	LDA (ZP),Y
	CMP #155
	BEQ ASCTSC5
	AND #$7F ;NO INV.
ASCTSC5	LDY #0
ASCTSC2	CMP (121),Y
	BEQ ASCTSC3
	INY
	BNE ASCTSC2
	INC BUYR
ASCTSC3	TYA
	LDY PARFUN
	STA (ZP),Y
	DEC PARFUN
	CPY #0
	BNE ASCTSC1
	LDY #1
	LDA BUYR
	BEQ ASCTSC4
	LDY #255
ASCTSC4	RTS

TRAPVCT	CMP #128
	BCS TRAPVC1
	CMP #64
	BCS TRAPVC0
	AND #07
	ASL
	TAX
	LDA TTRAP,X
	TAY
	LDA TTRAP+1,X
	TAX
	TYA
	LDY #1
	RTS
TRAPVC0	AND #$0F
	ASL
	TAX
	LDA TUSVEC,X
	TAY
	LDA TUSVEC+1,X
	TAX
	TYA
	LDY #1
	RTS
TRAPVC1	CMP #128+64
	BCS TRAPVC2
	AND #$07
	ASL
	STX ZP
	TAX
	LDA ZP
	STA TTRAP,X
	TYA
	STA TTRAP+1,X
	LDY #1
	RTS
TRAPVC2	AND #$0F
	ASL
	STX ZP
	TAX
	LDA ZP
	STA TUSVEC,X
	TYA
	STA TUSVEC+1,X
	LDY #1
	RTS

SETTIME	STA CLKH
	STX CLKM
	STY CLKS
	LDA #0
	STA CLK
	LDY #1
	RTS
SETDATE	STA DTMD
	STX DTMM
	STY DTMR
	LDY #1
	RTS

REDTIME	LDA CLKH
	LDX CLKM
	LDY CLKS
	RTS
REDDATE	LDA DTMD
	LDX DTMM
	LDY DTMR
	RTS


SFNADR	CMP #$10
	BCC SFNAD1
	AND #$0F
	STX ZP
	ASL	;*2
	TAX
	LDA ZP
	STA TABFN,X
	TYA
	STA TABFN+1,X
	LDY #0
	RTS
SFNAD1	AND #$0F
	ASL	;*2
	TAX
	LDA TABFN,X
	TAY
	LDA TABFN+1,X
	TAX
	TYA
	LDY #1
	RTS

WAITSLP	LDX MSLP
	STA MSLP
	TXA
	LDX #0
	LDY #1
	RTS

CHKEY	CPX #128
	BCC CHKEYR
	STA KEYDEF,Y
	LDY #1
	RTS
CHKEYR	LDA KEYDEF,Y
	LDX #0
	LDY #1
	RTS

QCREMEM	JMP (TUSVEC)
QCLOMEM	JMP (TUSVEC+2)
QCHMEM	JMP (TUSVEC+4)

CREMEM	STX ZP
	STY ZP+1
	STA POM
	LDX POM
	CPX #$10
	BCS CREMEE
	LDY #0
CREME1	LDA $FF00,Y
	BNE CREME2
	DEX
	BEQ CREME3
CREME2	INY
	CPY #64
	BCC CREME1
CREMEE	STX POM
	LDA #255
	SEC
	SBC POM
	LDY #146
	RTS
CREME3	LDY #0
CREME4	LDA $FF83,Y
	BPL CREME5
	INY
	INY
	INY
	INY
	CPY #64
	BCC CREME4
	BCS CREMEE
CREME5	LDA ZP
	STA $FF80,Y
	LDA ZP+1
	STA $FF81,Y
	LDA POM
	STA $FF82,Y
	LDA #$C0
	STA $FF83,Y
	TYA
	LSR
	LSR	;/4
	STA ZP2
	ASL
	ASL
	ASL
	ASL
	STA ZP2+1
	LDX #0
	LDY #63
CREME6	LDA $FF00,Y
	BNE CREME7
	TXA
	AND #$0F
	ORA ZP2+1
	STA $FF00,Y
	INX
	CPX POM
	BCS CREME8
CREME7	DEY
	BPL CREME6
	BMI CREMEE
CREME8	LDA ZP2
	STA POM
	LDX #0
	JSR CHMEM
	BMI CREME9
	LDA POM
	LDY #1
CREME9	RTS

CLOMEM	AND #$0F
	STA POM
	LDX #128
	JSR CHMEM
	BMI CLOMEE
	LDA POM
	ASL
	ASL
	ASL
	ASL
	STA ZP
	LDY #0
CLOME1	LDA $FF00,Y
	AND #$F0
	CMP ZP
	BNE CLOME2
	LDA #0
	STA $FF00,Y
CLOME2	INY
	CPY #64
	BCC CLOME1
	LDA POM
	ASL
	ASL	;*4
	TAY
	LDA #0
	STA $FF80,Y
	STA $FF81,Y
	STA $FF82,Y
	STA $FF83,Y
	LDY #1
CLOMEE	RTS

CHMEM	AND #$0F
	BEQ CHMEME
	STA ZP2
	ASL
	ASL
	ASL
	ASL
	STA CHMPOM
	TXA
	LSR	;/2
	AND #$40
	STA ZP
	LDA ZP2
	ASL
	ASL	;*4
	TAY
	LDA $FF83,Y
	BPL CHMEME
	AND #$40
	CMP ZP
	BEQ CHMEOK
	LDA $FF80,Y
	STA ZP
	LDA $FF81,Y
	STA ZP+1
	LDA $FF82,Y
	STA CHMDL
	LDA $FF83,Y
	EOR #$40
	STA $FF83,Y
	LDA #0
	STA ZP2
CHMEM0	LDY #0
CHMEM1	LDA $FF00,Y
	CMP CHMPOM
	BEQ CHMEM2
	INY
	CPY #64
	BCC CHMEM1
CHMEME	LDY #146
	RTS
CHMEM2	TYA
	CLC
	ADC #$C0
	STA ZP2+1
	LDY #0
CHMEM3	LDA (ZP),Y
	TAX
	LDA (ZP2),Y
	STA (ZP),Y
	TXA
	STA (ZP2),Y
	INY
	BNE CHMEM3
	INC ZP+1
	INC CHMPOM
	DEC CHMDL
	BNE CHMEM0
CHMEOK	LDY #1
	RTS

	ORG $FFF8
	DFW 0
	DFW NMIVKT
	DFW 0	;RESETVKT
	DFW IRQVKT

* ---- INIT BIS INTERN ---- *

	ORG 738	;INIT
	DFW SINIT

	ORG 736	;START
	DFW CAD

