*	BOOT TDOS VER %00 *

	ORG $8000

INFBUF	EQU $7A00	;?????
POMBUF	EQU $0400	;POMOCNY BUFER -> POD ROM
DATBUR	EQU $7C00
FMSBUR	EQU $7D00
DATBUF	EQU $7E00
FMSBUF	EQU $7F00

ZPOM	EPZ 203	;4
INFB	EPZ 128	;9
DL	EPZ 130	;1
K144	EPZ 132
K145	EPZ 133
K146	EPZ 134
K147	EPZ 135
K148	EPZ 136
K149	EPZ 137
ZP	EPZ 138	;9

SK1	EQU 736
SK2	EQU 738
SK3	EQU 739
SK4	EQU 771
SK5	EQU 772
SK6	EQU 773
SK7	EQU 776
SK8	EQU 777
SK9	EQU 778
SK10	EQU 779
SK11	EQU 834
SK12	EQU 836
SK13	EQU 837
SK14	EQU 840

START	LDA $9009
	STA SK21
	LDA $900F
	STA SROOT1
	LDA $9010
	STA SROOT2
	JSR ASK27
	LDX #0
	LDA SK21
	STA 145
	STA 144
	STA SK7
	BNE START1
	INX
START1	STX SK8
	LDA ZDIR+15
	STA SK22
	LDA ZDIR+16
	STA SK23
	LDA #INFBUF&255
	STA 146
	STA INFB
	LDA #INFBUF>>8
	STA 147
	STA INFB+1
	LDA SK21
	BEQ START2
	LDA ZDIR+17
	ASL
	STA ZDIR+17
	LDA ZDIR+18
	LSR
	STA 149
	STA DL+1
	LDA ZDIR+17
	ROR
	STA 148
	STA DL
	JMP START3

BOOTEND	RTS

START2	LDA ZDIR+18
	STA 149
	STA DL+1
	LDA ZDIR+17
	STA 148
	STA DL
START3	JSR SK41 ;NAHRA CELY BLOK
	JSR ROMON
STARTC	LDA DL+1
	BMI BOOTEND
	ORA DL
	BEQ BOOTEND
	LDY #0
	LDA (INFB),Y
	CMP #45	;'-'
	BEQ START9
	LDX #0
START4	LDA (INFB),Y
	CMP #155
	BEQ START6
	STA NAME,X
	INC INFB
	BNE START5
	INC INFB+1
START5	LDA DL
	BNE STAR55
	DEC DL+1
STAR55	DEC DL
	INX
	CPX #14
	BCC START4
	INY
	LDA (INFB),Y
	DEY
	CMP #155
	BEQ START6
	JMP SK31
START6	INC INFB
	BNE START7
	INC INFB
START7	LDA DL
	BNE STAR77
	DEC DL+1
STAR77	DEC DL
START8	LDA #32
	STA NAME,X
	INX
	CPX #14
	BCC START8
	JSR ASK27
	JSR SK27
	JMP STARTC
START9	INC INFB
	BNE START10
	INC INFB+1
START10	LDA DL
	BNE START11
	DEC DL+1
START11	DEC DL
	LDX #0
START12	LDY #0
START13	LDA TABCOM,X
	CMP #155
	BEQ START15
	CMP (INFB),Y
	BNE START14
	INX
	INY
	JMP START13
START14	INX
	LDA TABCOM,X
	CMP #155
	BNE START14
	INX
	INX
	INX
	CPX #TABCOK-TABCOM
	BCC START12
STARFE	JMP SK31 ;???
START15	LDA TABCOM+1,X
	STA ZP
	LDA TABCOM+2,X
	STA ZP+1
	JMP (ZP)

ININFB	INY
	TYA
	CLC
	ADC INFB
	STA INFB
	LDA INFB+1
	ADC #0
	STA INFB+1
	LDX DL
	STY DL
	TXA
	SEC
	SBC DL
	STA DL
	LDA DL+1
	SBC #0
	STA DL+1
	RTS

SBASON	INY
	LDA (INFB),Y
	CMP #155
	BNE STARFE
	JSR ININFB
	LDA #253
	STA 54017
	LDA #0
	STA 1016
	LDA 106
	CMP #160
	BCC SBASO1
	LDA #160
	STA 106
SBASO1	JSR $EF94	;OPEN 'E:'
	JMP STARTC

SBASOF	INY
	LDA (INFB),Y
	CMP #155
	BNE STARFE
	JSR ININFB
	LDA #255
	STA 54017
	LDA #1
	STA 1016
	LDA 106
	CMP #160
	BNE SBASO1
	LDA #192
	STA 106
	JMP SBASO1

SCAR	LDA 1016
STARFE1	BNE STARFE
	LDA 54017
	CMP #253
	BNE STARFE1
	JMP ($BFFA)

SDOS	JMP (10)

SRES	JMP $E474	;RESET

SSTAR	JMP (SK1)	;START PROG


TABCOM	ASC 'BASIC ON'
	DFB 155
	DFW SBASON
	ASC 'BASIC OFF'
	DFB 155
	DFW SBASOF
	ASC 'CAR'
	DFB 155
	DFW SCAR
	ASC 'DOS'
	DFB 155
	DFW SDOS
	ASC 'RESET'
	DFB 155
	DFW SRES
	ASC 'START'
	DFB 155
	DFW SSTAR
TABCOK	OUT

SK21	DFB 0
SK22	DFB 0
SK23	DFB 0
ROOT1	DFB 0
ROOT2	DFB 0
SROOT1	DFB 0
SROOT2	DFB 0

NAME	ASC 'TDOS.BOOT.INF '

ZDIR	DFW 0,0,0,0,0,0,0,0,0,0,0,0

TERR	ASC 'BOOT ERROR'
	DFB $9B	;EOL

ASK24	LDA ROOT1
	STA SK9
	LDA ROOT2
	STA SK10
	LDA #FMSBUR&255
	LDX #FMSBUR>>8
	JSR ASK33
	LDA FMSBUR
	STA ROOT1
	LDA FMSBUR+1
	STA ROOT2
	LDY #4	;PRVY ZAZNAM
	STY K145
ASK25	LDY K145
	CPY SK21
	BEQ ASK24
	LDA FMSBUR,Y
	STA SK9
	LDA FMSBUR+1,Y
	STA SK10
	INY
	INY
	STY K145
	RTS

ASK27	LDX #0
	LDA SK21
	STA K145
	STA K144
	STA SK7
	BNE ASK28
	INX
ASK28	STX SK8
	LDA SROOT1
	STA ROOT1
	LDA SROOT2
	STA ROOT2
ASK29	LDA #ZDIR&255
	STA K146
	LDA #ZDIR>>8
	STA K147
	LDA #23
	STA K148
	LDA #0
	STA K149
	JSR ASK41 ;NAHRA CELY BLOK
	LDA ZDIR
	AND #%11000001
	CMP #%00000001
	BNE ASK29
	LDX #0
ASK30	LDA ZDIR+1,X
	CMP NAME,X
	BNE ASK29
	INX
	CPX #14
	BCC ASK30
	RTS

ASK31	JMP SK31

ASK33	LDY #64	;VSTUP
	STY SK4
	STA SK5	;L - BUFER
	STX SK6	;H - BUFER
	LDA SK9
	ORA SK10
	BEQ ASK31 ;SEKTOR=0 - ERROR
	JSR SK49 ;SIOINTERFACE
	BMI ASK31 ;CYBA
	RTS

ASK34	LDA #0
	STA K149
	STA K148 ;DLZ=0
ASK35	LDX K144
	CPX SK21 ;DLZ SEK.
	BEQ ASK36	;NAHRAT DALSI SEK.
	LDA DATBUR,X
	INC K144
	RTS
ASK36	JSR ASK25	;NAST. 778,9 Z FMS
	LDA K149 ;H - DLZ
	BNE ASK38	;AK VIAC AKO 1 SEK.
	LDA SK21 ;DL. SEKTORU
	BEQ ASK37
	LDA K148 ;L - DLZ
	BMI ASK38	;AK VIAC AKO 1 SEK.
ASK37	LDA #DATBUR&255
	LDX #DATBUR>>8
	JSR ASK33 ;NAHRA SEK.
	SEC
	ROL K144 ;144=1
	LDA DATBUR
	RTS

ASK38	LDA K146
	LDX K147
	JSR ASK33 ;NAH.SEK.
	LDA K146 ;\
	CLC
	ADC SK7
	STA K146 ;  ADR=ADR+DL.SEK.
	LDA K147
	ADC SK8
	STA K147 ;/
	SEC	;\
	LDA K148
	SBC SK7
	STA K148 ;  DLZ=DLZ-DL.SEK.
	LDA K149
	SBC SK8
	STA K149 ;/
	JMP ASK36	;CONT. LOAD

ASK39	LDA K148
	BNE ASK40
	DEC K149
ASK40	DEC K148 ;DEC DLZ
ASK41	JSR ASK35	;NAHRA
	LDY #0
	STA (K146),Y
	INC K146
	BNE ASK42
	INC K147
ASK42	LDA K148
	ORA K149
	BNE ASK39	;ESTE NIEJE KONIEC
	RTS
*------

SK24	LDA SK22
	STA SK9
	LDA SK23
	STA SK10
	LDA #FMSBUF&255
	LDX #FMSBUF>>8
	JSR SK33
	LDA FMSBUF
	STA SK22
	LDA FMSBUF+1
	STA SK23
	LDY #4	;PRVY ZAZNAM
	STY 145
SK25	LDY 145
	CPY SK21
	BEQ SK24
	LDA FMSBUF,Y
	STA SK9
	LDA FMSBUF+1,Y
	STA SK10
	INY
	INY
	STY 145
AIN	RTS

SK26	JMP (SK2)	;INIT.

SK27	JSR ROMOFF
	LDX #0
	LDA SK21
	STA 145
	STA 144
	STA SK7
	BNE SK28
	INX
SK28	STX SK8
	LDA ZDIR+15
	STA SK22
	LDA ZDIR+16
	STA SK23
	JSR SK34
	STA 150
	JSR SK34
	AND 150
	CMP #255 ;BIN. SUBOR?
	BNE SK31 ;NIE - ERROR NO DOS
SK29	LDA #AIN&255
	STA SK2
	LDA #AIN>>8
	STA SK3
	JSR SK34
	STA 146
	JSR SK34
	STA 147
	ORA 146
	BEQ SK30 ;UZ NIEJE DALSI BLOK
	JSR SK34
	SEC
	SBC 146
	PHA
	PHP
	JSR SK34
	PLP
	SBC 147
	STA 149
	PLA
	STA 148
	JSR SK41 ;NAHRA CELY BLOK
	JSR ROMON
	JSR SK26 ;INICIALIZACIA (RTS)
	JSR ROMOFF
	JMP SK29 ;LOAD DALSI BLOK
SK30	JSR ROMON
	RTS

SK31	JSR ROMON
	LDA #TERR&255
	LDX #TERR>>8
	STA SK12
	STX SK13
	STX SK14
	LDA #9	;PRINT
	STA SK11
	LDX #0	;#0
	JSR SK48 ;CIO - PRINT ERROR
SK32	JMP SK32 ;WAIT

SK33	LDY #64	;VSTUP
	STY SK4
	STA ZPOM
	STX ZPOM+1
	LDA #POMBUF&255
	LDX #POMBUF>>8
	STA SK5	;L - BUFER
	STX SK6	;H - BUFER
	LDA SK9
	ORA SK10
	BEQ SK31 ;SEKTOR=0 - ERROR
	JSR ROMON
	JSR SK49 ;SIOINTERFACE
	BMI SK31 ;CYBA
	JSR ROMOFF
	LDY #0
SK333	LDA POMBUF,Y
	STA (ZPOM),Y
	INY
	BNE SK333
	RTS

SK34	LDA #0
	STA 149
	STA 148	;DLZ=0
SK35	LDX 144
	CPX SK21 ;DLZ SEK.
	BEQ SK36 ;NAHRAT DALSI SEK.
	LDA DATBUF,X
	INC 144
	RTS
SK36	JSR SK25 ;NAST. 778,9 Z FMS
	LDA 149	;H - DLZ
	BNE SK38 ;AK VIAC AKO 1 SEK.
	LDA SK21 ;DL. SEKTORU
	BEQ SK37
	LDA 148	;L - DLZ
	BMI SK38 ;AK VIAC AKO 1 SEK.
SK37	LDA #DATBUF&255
	LDX #DATBUF>>8
	JSR SK33 ;NAHRA SEK.
	SEC
	ROL 144	;144=1
	LDA DATBUF
	RTS

SK38	LDA 146
	LDX 147
	JSR SK33 ;NAH.SEK.
	LDA 146	;\
	CLC
	ADC SK7
	STA 146	;  ADR=ADR+DL.SEK.
	LDA 147
	ADC SK8
	STA 147	;/
	SEC	;\
	LDA 148
	SBC SK7
	STA 148	;  DLZ=DLZ-DL.SEK.
	LDA 149
	SBC SK8
	STA 149	;/
	JMP SK36 ;CONT. LOAD

SK39	LDA 148
	BNE SK40
	DEC 149
SK40	DEC 148	;DEC DLZ
SK41	JSR SK35 ;NAHRA
	LDY #0
	STA (146),Y
	INC 146
	BNE SK42
	INC 147
SK42	LDA 148
	ORA 149
	BNE SK39 ;ESTE NIEJE KONIEC
	RTS

ROMON	PHA
	LDA #255
	STA 54017
	LDA #192
	STA 54286
	STA 53774
	PLA
	RTS
ROMOFF	PHA
	LDA #0
	STA 54286
	STA 53774
	LDA #254
	STA 54017
	PLA
	RTS

SK48	EQU 58454
SK49	EQU 58457

	ORG 736
	DFW START

