*************************************
*	Tomi FIS   ver.1.0  -ROM	*
*	       23.10.93 - 07.11.93 *
* COPYRIGHT (c)Tomi		*
*************************************

TRAP	MACRO M,F
	DFB 0
	DFB M*32+F
	MEND

	ORG $1500

UT	EPZ 24	;UKAZOV. NA TABULKU
PARFUN	EPZ 73	;CISLO FUNKCIE-DOCAS
ZP	EPZ 71	;2
PTAB	EQU $0400

FUNTAB	DFW INIT 	; 0
	DFW VERZIA	; 1
	DFW CHIPSEL	; 2
	DFW RWD		; 3
	DFW CWD		; 4
	DFW NEWDSK	; 5
	DFW FILEINF	; 6
	DFW FILEINN	; 7
	DFW CHFILIN	; 8
	DFW OPEN 	; 9
	DFW GET		;10
	DFW CALLDRV	;11
	DFW PUT		;12
	DFW CLOSE	;13
	DFW NOTE 	;14
	DFW POINT	;15
	DFW ERASE	;16
	DFW FFSEC	;17
	DFW SFSEC	;18
	DFW SBSEC	;19
	DFW SBTSEC	;20
	DFW SOKSEC	;21
	DFW GFRDSK	;22
	DFW BCKDSK	;23
	DFW CREDT	;24
	DFW CHVEC	;25
	DFW BCKVEC	;26
	DFW REVEC	;27
	DFW FORMAT	;28
	DFW SOFTFOR	;29
	DFW REWRSI	;30
	DFW DRIVEC	;31

BASINI	LDY #LINKTAB&255
	LDA #LINKTAB>>8
	SEC
	TRAP 6,28
	LDY #1
	CLC
	RTS

LINKTAB	DFB 0,0,0,0,0,0,0,0,0,0,0,0
	JMP INIFIS
	DFB 0
	DFW $0100,0

INIFIS	LDA #$85
	LDX #FIS&255
	LDY #FIS>>8
	TRAP 6,0
	JSR INIT
	CLC
	RTS

FIS	PHP
	PHA
	TXA
	PHA
	LDA PARFUN
	ASL	;*2
	TAX
	LDA FUNTAB,X
	STA ZP
	LDA FUNTAB+1,X
	STA ZP+1
	LDA 54017
	STA ROMP
	LDA #254
	STA 54017
	PLA
	TAX
	PLA
	PLP
	JSR FNCALL
	PHP
	PHA
	LDA ROMP
	STA 54017
	PLA
	PLP
	RTS
FNCALL	JMP (ZP)

ROMP	DFB 255
*BUAC	 DFB 0
BUXR	DFB 0
BUYR	DFB 0

*-------------------------*
	LDA #$00 ;SERIAL NUMBER
	LDX #$00 ; A+X*Y
	LDY #$00
	RTS	; NIC

VERZIA	LDA #%00001000	;VERZIA
	RTS

*-----------------------------------*

	ORG $E900

CDRV	BIT FINP6
	BEQ CDRV1
	JMP (FINP5)
CDRV1	LDY #EFNNR
	SEC
	RTS

TESTDSK	LDA CD
TESTDSX	AND #$03
	TAY
	LDA ODISK,Y
	BMI TESTDER
	AND #$07
	TRAP 7,2
	TRAP 7,9
	BMI TESTDEE
	LDY #1
	RTS
TESTDER	LDY #EFREDSK
TESTDEE	RTS

CMPNAM	LDY #0
	LDX #1
CMPN1	LDA (ZP),Y
	CMP #155
	BNE CMPN1R
	JMP CMPNR
CMPN1R	CMP #'['
	BEQ CMPN3
	CMP #'('
	BEQ CMPN14
	CMP #42	;'*'
	BEQ CMPN6
	CMP #'?'
	BEQ CMPN2
	CMP ZDIR,X
	BEQ CMPN2
CMPNE	SEC
	RTS
CMPN2	INY
	INX
	CPX #15
	BCC CMPN1
CMPNO	CLC
	RTS
CMPN3	INY
	LDA (ZP),Y
	CMP #'!'
	BEQ CMPN5
	JSR CMPNHH
	BMI CMPNE
	BCC CMPN2
	BCS CMPNE
CMPN5	JSR CMPNH
CMPNEF	BMI CMPNE
	BCS CMPN2
	BCC CMPNE
CMPN14	INY
	LDA (ZP),Y
	CMP #'!'
	BEQ CMPN15
	DEY
	JSR CMPNS
	BMI CMPNE
	BCC CMPN2
	BCS CMPNE
CMPN15	JSR CMPNS
	BMI CMPNE
	BCS CMPN2
	BCC CMPNE
CMPN6	INY
	LDA (ZP),Y
	CMP #155
	BEQ CMPNO
	CMP #42	;'*'
	BEQ CMPN6
	CMP #'?'
	BEQ CMPN8
CMPN7	CMP ZDIR,X
	BEQ CMPN8
CMPN18	INX
	CPX #15
	BCC CMPN7
	BCS CMPNE
CMPN8	STX CPOM
	STY CPOM1
CMPN9	INY
	INX
	LDA (ZP),Y
	CMP #155
	BEQ CMPNR
	CMP #'['
	BEQ CMPN11
	CMP #'('
	BEQ CMPN16
	CMP #'?'
	BEQ CMPN10
	CMP #42	;'*'
	BEQ CMPN6
	CMP ZDIR,X
	BEQ CMPN10
	LDX CPOM
	LDY CPOM1
	JMP CMPN18
CMPN10	CPX #14
	BCC CMPN9
	JMP CMPNO
CMPN11	INY
	LDA (ZP),Y
	CMP #'!'
	BEQ CMPN13
	JSR CMPNHH
CMPNEG	BMI CMPNEF
	BCC CMPN10
CMPN12	LDX CPOM
	LDY CPOM1
	JMP CMPN18
CMPN13	JSR CMPNH
	BMI CMPNEG
	BCC CMPN12
	BCS CMPN10
CMPN16	INY
	LDA (ZP),Y
	CMP #'!'
	BEQ CMPN17
	DEY
	JSR CMPNS
	BMI CMPNEG
	BCC CMPN10
	BCS CMPN12
CMPN17	JSR CMPNS
	BMI CMPNEG
	BCC CMPN12
	BCS CMPN10
CMPNR	LDA ZDIR,X
	CMP #32
	BNE CMPNEG
	INX
	CPX #15
	BCC CMPNR
	JMP CMPNO
CMPNH	INY
CMPNHH	LDA (ZP),Y
	CMP #155
	BEQ CMPNH3
	CMP #']'
	BEQ CMPNH2
	CMP #45	;'-'
	BEQ CMPNH4
	CMP ZDIR,X
	BNE CMPNH
CMPNH1	INY
	LDA (ZP),Y
	CMP #155
	BEQ CMPNH3
	CMP #']'
	BNE CMPNH1
	LDA #0
	CLC
	RTS
CMPNH2	LDA #0
	SEC
	RTS
CMPNH3	LDA #255
	SEC
	RTS
CMPNH4	DEY
	LDA (ZP),Y
	INY
	CMP ZDIR,X
	BCC CMPNH
	INY
	LDA ZDIR,X
	CMP #155
	BEQ CMPNH3
	CMP (ZP),Y
	BCC CMPNH
	BCS CMPNH1
CMPNS	STX CPOM2
CMPNS1	INY
	LDA (ZP),Y
	CMP #155
	BEQ CMPNH3
	CMP #')'
	BEQ CMPNS5
	CMP #','
	BEQ CMPNS5
	CMP #'['
	BEQ CMPNS7
	CMP ZDIR,X
	BNE CMPNS2
CMPNS0	INX
	JMP CMPNS1
CMPNS2	LDX CPOM2
CMPNS3	INY
	CMP #')'
	BEQ CMPNS4
	CMP #155
	BEQ CMPNH3
	CMP #','
	BNE CMPNS3
	BEQ CMPNS1
CMPNS4	LDA #0
	SEC
	RTS
CMPNS5	LDA (ZP),Y
	CMP #155
	BEQ CMPNH3
	CMP #')'
	BEQ CMPNS6
	INY
	JMP CMPNS5
CMPNS6	LDA #0
	CLC
	RTS
CMPNS7	INY
	LDA (ZP),Y
	CMP #'!'
	BEQ CMPNS8
	JSR CMPNHH
	BMI CMPNH3
	BCC CMPNS0
	BCS CMPNS2
CMPNS8	JSR CMPNH
	BMI CMPNH3
	BCS CMPNS0
	BCC CMPNS2


*-TABULKY-*
POM	DFB 0
POM1	DFB 0
POM2	DFB 0
CPOM	DFB 0
CPOM1	DFB 0
CPOM2	DFB 0
FPOM	DFB 0
FPOM1	DFB 0
FPOM2	DFB 0
FINP1	DFB 0
FINP2	DFB 0
FINP3	DFB 0
FINP4	DFB 0
FINP5	DFB 0
FINP6	DFB 0
FINP7	DFB 0
IODRP	DFB 0
CD	DFB 0
PCD	DFB 0
BVECP	DFB 0
BVEC	DFW 0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0
ZDIR	DFW 0,0,0,0,0,0,0,0,0,0,0,0
DIBUF	DFW 0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0
DIBUF2	DFW 0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0
ODISK	DFB $80,$80,$80,$80
ODISK2	DFB 0,0,0,0
OHAN	DFB $80,$80,$80,$80
OHAD	DFB $80,$80,$80,$80
TDRVRS	DFW 0,0,0,0
THAN	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0
TNAM	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0,0,0,0,0,0,0,0,0
	DFW 0,0,0,0

*-FUNKCIE-*

INIT	LDA #0
	TAX
INIT1	STA TNAM,X
	STA THAN,X
	INX
	CPX #128 ;32*4
	BCC INIT1
	LDX #0
INIT2	LDA #$80
	STA OHAN,X
	STA OHAD,X
	STA ODISK,X
	LDA #0
	STA ODISK2,X
	INX
	CPX #4
	BCC INIT2
	LDA #0
	STA BVECP
	STA UT
	LDA #4
	STA UT+1
	LDA #255
	TRAP 7,0
	LDY #1
	RTS


CHIPSEL	AND #$03
	LDX CD
	STX POM1
	STA POM
	TAY
	LDA ODISK,Y
	BMI CHIPSR
	LDA POM
	STA CD
	JSR TESTDSK
	BPL CHIPSE1
	LDA POM1
	STA CD
	TYA
	RTS
CHIPSE1	LDY #1
	RTS
CHIPSR	LDY #EFREDSK
	RTS

RWD	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #21*2
	STA ZP
	LDA TDRVRS+1,Y
	ADC #0
	STA ZP+1
	JMP (ZP)

CWD	STY POM
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #21*2
	STA ZP
	LDA TDRVRS+1,Y
	ADC #0
	STA ZP+1
	LDY POM
QJMPZP	JMP (ZP)


NEWDSK	AND #$07
	STA POM
	LDY #0
NEWDSC	LDA ODISK,Y
	BMI NEWDS0
	INY
	CPY #4
	BCC NEWDSC
	LDY #EBZYDSK
	RTS
NEWDS0	STY POM2
	LDA POM
	TRAP 7,8
	BPL NEWDSEF
	RTS
NEWDSEF	LDA POM
	TRAP 7,2
	LDX #DIBUF&255
	LDY #DIBUF>>8
	TRAP 7,12
	LDA #0
	STA NWDS4
NWDST	LDX NWDS4
	CPX POM2
	BEQ NWDST1
	LDA ODISK,X
	BMI NWDST1
	TRAP 7,2
	LDX #DIBUF2&255
	LDY #DIBUF2>>8
	TRAP 7,12
	LDY #31
NWDST0	LDA DIBUF,Y
	CMP DIBUF2,Y
	BNE NWDST1
	DEY
	BPL NWDST0
	LDA POM
	TRAP 7,7 ;SVD
	LDY #EBZYDSK
	RTS
NWDST1	INC NWDS4
	LDA NWDS4
	CMP #4
	BCC NWDST
	LDA POM
	TRAP 7,2
	LDA POM2
	STA PTAB
	LDA POM
	STA PTAB+1
	LDA #DIBUF&255
	STA PTAB+2
	LDA #DIBUF>>8
	STA PTAB+3
	LDA #0
	STA NWDS4
NWDS1	LDA NWDS4
	ASL
	TAY
	LDA TDRVRS,Y
	STA ZP
	LDA TDRVRS+1,Y
	STA ZP+1
	JSR QJMPZP	;JSR (ZP)
	BCC NWDS2
	INC NWDS4
	LDA NWDS4
	CMP #4
	BCC NWDS1
	LDA POM
	TRAP 7,7 ;SVD
	LDY #EBFORM
	RTS
NWDS2	LDY POM2
	LDA NWDS4
	STA ODISK2,Y
	LDY POM2
	LDA POM
	STA ODISK,Y
	LDA POM2
	STA CD
	JMP CHIPSEL
NEWDSE	RTS
NWDS4	DFB 0

FILEINF	LDY #0
	LDX #0
	LDA (UT),Y
	BMI FILINF
	JMP FILINCL	;CLOSE
FILINF	JSR TESTDSK
	BMI NEWDSE	;RTS
FILIN0	LDA OHAD,X
	BMI FILIN1
	INX
	CPX #4
	BCC FILIN0
	LDY #ENOHAN
	RTS
FILIN1	STX POM
	LDA #0
	TAX
FILIN2	STA PTAB+8,X
	INX
	CPX #8
	BCC FILIN2
	LDY #1
	LDA (UT),Y
	STA FINP1
	INY
	LDA (UT),Y
	STA FINP2
	INY
	LDA (UT),Y
	STA ZP
	INY
	LDA (UT),Y
	STA ZP+1
	INY	
	LDA (UT),Y
	STA FINP3
	INY
	LDA (UT),Y
	STA FINP4
	LDA #ZDIR&255
	STA PTAB+2
	LDA #ZDIR>>8
	STA PTAB+3
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #4*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	LDY #0
	LDA (ZP),Y
	CMP #'>'
	BNE FIL7N7
	LDA #$FF
	STA PTAB+12	;8+4
	STA PTAB+13	;8+5
	INC ZP
	BNE FIL7N7
	INC ZP+1
FIL7N7	JSR CDRV
	LDY #0
	LDA (ZP),Y
	CMP #'<'
	BNE FILIN7
	INY
	LDA (ZP),Y
	CMP #155
	BEQ FILIN9
	BNE FILIN8P
FILIN7	JSR CDRV
	BPL FILIN3
	RTS
FILIN3	LDY #0
	LDA #128
	STA FINP7
FILIN4	LDA (ZP),Y
	CMP #155
	BEQ FILIN6
	CMP #'>'
	BEQ FILIN5
	INY
	CPY #32
	BCC FILIN4
	LDY #ELNGNAM
	RTS
FILIN5	STY FINP7
	LDA #155
	STA (ZP),Y
	JSR CMPNAM
	BCS FILIN7
	LDA ZDIR
	AND #%11000000
	CMP #%01000000
	BNE FILIN7
	BEQ FILIN8
FILIN6	JSR CMPNAM
	BCS FILIN7
	LDA ZDIR
	AND FINP4
	CMP FINP3
	BNE FILIN7
FILIN8	LDA FINP7
	BMI FILIN9
	CLC
	ADC ZP
	STA ZP
	LDA ZP+1
	ADC #0
	STA ZP+1
FILIN8P	INC ZP
	BNE FIL8N8
	INC ZP+1
FIL8N8	LDA ZDIR+15
	STA PTAB+4
	LDA ZDIR+16
	STA PTAB+5
	LDA #0
	STA PTAB+6
	LDA #0
	STA PTAB+7
	JMP FIL7N7
FILIN9	LDA POM
	ASL
	ASL
	ASL
	ASL
	ASL	;*32
	STA POM1
	TAX
	LDY #0
FIL9N9	LDA (ZP),Y
	STA TNAM,X
	INX
	INY
	CMP #155
	BNE FIL9N9
	LDA FINP1
	STA ZP
	LDA FINP2
	STA ZP+1
	LDY #24
FILIN10	LDA ZDIR
	STA (ZP),Y
	DEY
	BPL FILIN10
	LDX POM1
	LDY #0
FILIN11	LDA PTAB+8,Y
	STA THAN,X
	INX
	INY
	CPY #8
	BCC FILIN11
	LDX #4
	LDY #3
FILIN12	LDA PTAB,X
	STA (UT),Y
	INX
	INY
	CPY #7
	BCC FILIN12
	LDY POM
	LDA CD
	STA OHAD,Y
	TAX
	TYA
	LDY #1
	RTS
FILINCL	AND #$03
	TAY
	LDA #$80
	STA OHAD,Y
	LDY #1
	RTS

FILNNE	LDY #ENOHAD
FILNNR	RTS

FILEINN	LDY #0
	LDA (UT),Y
	AND #$03
	STA POM
	TAX
	LDA OHAD,X
	BMI FILNNE
	STA PCD
	JSR TESTDSX
	BMI FILNNR
	LDY #1
	LDA (UT),Y
	STA FINP1
	INY
	LDA (UT),Y
	STA FINP2
	LDA #ZDIR&255
	STA PTAB+2
	LDA #ZDIR>>8
	STA PTAB+3
	LDA POM
	ASL
	ASL
	ASL
	ASL
	ASL
	STA POM1
	TAX
	LDY #0
FILNN0	LDA THAN,X
	STA PTAB+8,Y
	INX
	INY
	CPY #8
	BCC FILNN0
	LDY PCD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #4*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	LDA POM1
	CLC
	ADC #TNAM&255
	STA ZP
	LDA #TNAM>>8
	ADC #0
	STA ZP+1
FILNN1	JSR CDRV
	BPL FILNN2
	RTS
FILNN2	JSR CMPNAM
	BCS FILNN1
	LDA ZDIR
	AND PTAB+3
	CMP PTAB+2
	BNE FILNN1
	LDA FINP1
	STA ZP
	LDA FINP2
	STA ZP+1
	LDY #24
FILNN3	LDA ZDIR
	STA (ZP),Y
	DEY
	BPL FILNN3
	LDX POM1
	LDY #0
FILNN4	LDA PTAB+8,Y
	STA THAN,X
	INX
	INY
	CPY #8
	BCC FILNN4
	LDX #4
	LDY #3
FILNN5	LDA PTAB,X
	STA (UT),Y
	INX
	INY
	CPY #7
	BCC FILNN5
	LDY #1
	RTS

CFILNE	LDY #ENOHAD
CFILNR	RTS

CHFILIN	LDY #0
	LDA (UT),Y
	AND #$03
	STA POM
	INX
	LDA OHAD,X
	BMI CFILNE
	STA PCD
	JSR TESTDSX
	BMI CFILNR
	LDY #1
	LDA (UT),Y
	STA PTAB+2
	INY
	LDA (UT),Y
	STA PTAB+3
	LDA POM
	ASL
	ASL
	ASL
	ASL
	ASL
	STA POM1
	TAX
	LDY #0
CHFIN0	LDA THAN,X
	STA PTAB+8,Y
	INX
	INY
	CPY #8
	BCC CHFIN0
	LDY PCD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #5*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JSR CDRV
	BPL CHFIN2
	RTS
CHFIN2	LDX POM1
	LDY #0
CHFIN3	LDA PTAB+8,Y
	STA THAN,X
	INX
	INY
	CPY #8
	BCC CHFIN3
	LDX #4
	LDY #3
CHFIN4	LDA PTAB,X
	STA (UT),Y
	INX
	INY
	CPY #7
	BCC CHFIN4
	LDY #1
	RTS

OPEN	JSR TESTDSK
	BMI OPENE
	LDX #0
OPEN1	LDA OHAN,X
	BMI OPEN2
	INX
	CPX #4
	BCC OPEN1
	LDY #ENOHND
OPENE	RTS
OPEN2	STX POM
	LDA #0
	TAY
OPEN3	STA PTAB,Y
	INY
	CPY #32
	BCC OPEN3
	LDY #1
	LDA (UT),Y
	STA PTAB+2
	INY
	LDA (UT),Y
	STA PTAB+3
	INY
	LDX #4
OPEN4	LDA (UT),Y
	STA PTAB,X
	INX
	INY
	CPY #7
	BCC OPEN4
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #6*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JSR CDRV
	BPL OPEN5
	RTS
OPEN5	LDA POM
	ASL
	ASL
	ASL
	ASL
	ASL	;*32
	TAY
	LDX #8
OPEN6	LDA PTAB,X
	STA THAN+8,Y
	INY
	INX
	CPX #32
	BCC OPEN6
	LDY POM
	LDA CD
	STA OHAN,Y
	LDX #0
	TYA
	LDY #0
	STA (UT),Y
	LDY #1
	RTS

GET	LDY #0
	LDA (UT),Y
	TAX
	STX POM
	LDA OHAN,X
	BMI GETE
	AND #$20
	BNE GETR
	LDA #7*2
	STA IODRP
IODRV	LDA OHAN,X
	AND #$03
	STA PCD
	JSR TESTDSX
	BMI GETER
	LDA POM
	ASL
	ASL
	ASL
	ASL
	ASL
	STA POM1
	TAX
	LDY #8
GET1	LDA THAN+8,X
	STA PTAB,Y
	INX
	INY
	CPY #32
	BCC GET1
	LDY #1
	LDX #4
GET2	LDA (UT),Y
	STA PTAB,X
	INY
	INX
	CPX #8
	BCC GET2
	LDY PCD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC IODRP
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JSR CDRV
	BPL GET3
	RTS
GET3	LDX POM1
	LDY #8
GET4	LDA PTAB,Y
	STA THAN+8,X
	INX
	INY
	CPY #32
	BCC GET4
	LDY #1
	RTS
GETE	LDY #ENOHND
GETER	RTS
GETR	LDY #ENOREAD
	RTS
GETEF	LDY #EFREDSK
	RTS

PUT	LDY #0
	LDA (UT),Y
	TAX
	STX POM
	LDA OHAN,X
	BMI GETE
	AND #$40
	BNE GETR
	LDA #8*2
	STA IODRP
	JMP IODRV

CLOSE	LDY #0
	LDA (UT),Y
	TAX
	STX POM
	LDA OHAN,X
	BMI GETE
	AND #$03
	STA PCD
	JSR TESTDSX
	BMI GETER
	LDA POM
	ASL
	ASL
	ASL
	ASL
	ASL
	TAX
	LDY #8
CLOSE1	LDA THAN+8,X
	STA PTAB,Y
	INX
	INY
	CPY #32
	BCC CLOSE1
	LDY PCD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #9*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JSR CDRV
	BPL CLOSE2
	RTS
CLOSE2	LDX POM
	LDA #$80
	STA OHAN,X
	LDY #1
	RTS

NOTE	LDY #0
	LDA (UT),Y
	TAX
	STX POM
	LDA OHAN,X
	BMI NOTEE
	LDA #10*2
	STA IODRP
	JMP IODRV
NOTEE	LDY #ENOHND
	RTS

POINT	LDY #0
	LDA (UT),Y
	TAX
	STX POM
	LDA OHAN,X
	BMI NOTEE
	LDA #11*2
	STA IODRP
	JMP IODRV

ERASE	LDY #8
	LDA #0
ERASE1	STA PTAB,Y
	DEY
	BPL ERASE1
	LDY #1
	LDA (UT),Y
	STA PTAB+2
	LDA (UT),Y
	STA PTAB+3
	JSR TESTDSK
	BMI ERASEE
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #12*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JSR CDRV
ERASEE	RTS

CALLDRV	ASL	;*2
	STA PPAC
	STX ZP
	STY ZP+1
	LDY #31
CALDR1	LDA (ZP),Y
	STA PTAB,Y
	DEY
	BPL CALDR1
	LDA PTAB
	BPL CALDR2
	LDA CD
CALDR2	STA PPCD
	JSR TESTDSX
	BMI ERASEE
	LDY PPCD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC PPAC
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JMP CDRV
PPAC	DFB 0
PPCD	DFB 0

FFSEC	JSR TESTDSK
	BMI ERASEE
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #13*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JMP CDRV

SFSEC	LDA #14*2
SXSEC	STX BUXR
	STY BUYR
	STA IODRP
	JSR TESTDSK
	BMI SFSECE
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC IODRP
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	LDX BUXR
	LDY BUYR
	JMP CDRV
SFSECE	RTS

SBSEC	LDA #15*2
	JMP SXSEC

SBTSEC	LDA #16*2
	JMP SXSEC

SOKSEC	LDA #17*2
	JMP SXSEC

GFRDSK	JSR TESTDSK
	BMI GFRDSE
	LDX CD
	LDA ODISK,X
	TRAP 7,2
	BMI GFRDSE
	LDX #DIBUF&255
	LDY #DIBUF>>8
	TRAP 7,12
	BMI GFRDSE
	LDA #DIBUF&255
	STA PTAB+2
	LDA #DIBUF>>8
	STA PTAB+3
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #18*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JMP CDRV
GFRDSE	RTS

BCKDSK	AND #$03
	STA PTAB
	TAY
	STY POM1
	LDA ODISK,Y
	BMI BCKDSE
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #1*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	JSR CDRV
	BMI BCKDSR
	LDY POM1
	LDA ODISK,Y
	STA POM
	LDA #$80
	STA ODISK,Y
	LDA POM
	AND #$07
	TRAP 7,7
	RTS
BCKDSE	LDY #EFREDSK
BCKDSR	RTS

CREDT	STX ZP
	STY ZP+1
	TRAP 6,5
	AND #$1F
	STA POM	;DEN
	TYA	;ROK
	ASL	;<<1
	LDY #0
	STA (ZP),Y
	TXA	;MESIAC
	LSR
	LSR
	LSR	;>>3
	AND #$01
	ORA (ZP),Y
	STA (ZP),Y
	TXA	;MESIAC
	ASL
	ASL
	ASL
	ASL
	ASL	;<<5
	ORA POM	;ROK
	INY
	STA (ZP),Y
	TRAP 6,4
	STY POM	;SEK.
	LDY #2
	ASL	;HOD.
	ASL
	ASL	;<<3
	STA (ZP),Y
	TXA	;MIN.
	LSR
	LSR
	LSR	;>>3
	AND #$07
	ORA (ZP),Y
	STA (ZP),Y
	INY
	LDA POM	;SEK.
	LSR	;>>1
	AND #$1F
	STA POM
	TXA	;MIN.
	ASL
	ASL
	ASL
	ASL
	ASL	;<<5
	ORA POM	;SEK.
	STA (ZP),Y
	LDY #1
	RTS

CHVEC	STX POM
	LDX BVECP
	CPX #31
	BCS CHVECE
	LDA UT
	STA BVEC,X
	LDA UT+1
	STA BVEC+1,X
	INC BVECP
	INC BVECP
	LDA POM
	STA UT
	STY UT+1
	LDY #1
	RTS
CHVECE	LDY #EFNNR
	RTS

BCKVEC	LDX BVECP
	CPX #2
	BCC BCKVECE
	DEC BVECP
	DEC BVECP
	LDA BVEC,X
	STA UT
	LDA BVEC+1,X
	STA UT+1
	LDY #1
	RTS
BCKVECE	LDY #EFNNR
	RTS

REVEC	LDA UT
	LDX UT+1
	LDY #1
	RTS

FORMAT	STA FPOM
	STX FPOM1
	TRAP 7,18
	BMI FORMATE
	STA PTAB+2
	STX PTAB+3
	LDA FPOM
	TRAP 7,7 ;SVD
	LDA #0
	STA FPOM2
	JMP SFOR1
FORMATF	LDY #EFNNR
FORMATE	RTS

SOFTFOR	CPX #$FA
	BNE FORMATF
	STA FPOM2
	JSR TESTDSK
	BMI FORMATE
	LDX CD
	BMI FORMATF
	STX FPOM
	LDA ODISK,X
	BMI FORMATF
	STA FPOM1
	LDA CD
	JSR BCKDSK
	BMI FORMATE
	LDA #0
	STA PTAB+2
	STA PTAB+3
SFOR1	LDY FPOM
	STY PTAB
	LDA FPOM1
	STA PTAB+1
	LDA FPOM2
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #9*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	LDX $0308
	JSR CDRV
	BPL SFOR2
	RTS
SFOR2	LDA FPOM
	LDX FPOM1
	JMP NEWDSK

REWRSI	CMP #$CC
	BNE VOID
	STX BUXR
	LDY CD
	STY PTAB
	LDA ODISK,Y
	STA PTAB+1
	LDA ODISK2,Y
	ASL
	TAY
	LDA TDRVRS,Y
	CLC
	ADC #20*2
	STA FINP5
	LDA TDRVRS+1,Y
	ADC #0
	STA FINP6
	LDX BUXR
	JMP CDRV

DRIVEC	CMP #$80
	BCC DRIVEB
	CMP #255
	BNE DRIVE4
	STX BUXR
	LDX #0
DRIVE1	LDA TDRVRS,X
	CMP #0
	BNE DRIVE2
	LDA TDRVRS+1,X
	CMP #0
	BEQ DRIVE3
DRIVE2	INX
	INX
	CPX #8
	BCC DRIVE1
	LDY #EFNNR
	RTS
DRIVE3	TXA
	LSR
	LDX BUXR
DRIVE4	AND #$03
	STX BUXR
	ASL
	TAX
	LDA BUXR
	STA TDRVRS,X
	TYA
	STA TDRVRS+1,X
	LDY #1
	RTS
DRIVEB	AND #$03
	ASL
	TAY
	LDA TDRVRS+1,Y
	TAX
	LDA TDRVRS,Y
	LDY #1
	RTS

VOID	LDY #EFNF
	RTS

* -ERRORS- *
EFNF	EQU 206
EFNNR	EQU 207
EFREDSK	EQU 208
EBZYDSK	EQU 209
*EDSKFUL  EQU 210
ENOHND	EQU 211
*ENOSEC	 EQU 212 	;???????
ENOREAD	EQU 213
*ENOWRT	 EQU 214 	;???????
EBFORM	EQU 215
ENOHAN	EQU 216
ENOHAD	EQU 217
ELNGNAM	EQU 218

	ORG 738	;INIT
	DFW BASINI	;INIC.TRAP

