*	BOOT - TDOS VER %00 *

	ORG $9000

DATBUF	EQU $8E00
FMSBUF	EQU $8F00

SK1	EQU 736
SK2	EQU 738
SK3	EQU 739
SK4	EQU 771
SK5	EQU 772
SK6	EQU 773
SK7	EQU 776
SK8	EQU 777
SK9	EQU 778
SK10	EQU 779
SK11	EQU 834
SK12	EQU 836
SK13	EQU 837
SK14	EQU 840

ZAC	DFB 0
	DFB 3	;DLZKA 3*128
	DFW ZAC	;0,$90
	DFW SK31 ;START ERROR

	JMP SK27

SK21	DFB 0,1	;DLZKA SEKTORU
	DFW 1440 ;POCET SEKTOROV
	DFW 4	;SEKTOR VTOC1
	DFW 5	;FMS PRE ROOT
	DFW 0	;DATUM
	DFW 0	;CAS
SK22	DFB 32	;L - SEKTOR S FMS
SK23	DFB 0	;H - SEKTOR S FMS
STAT	DFB $71	;STATUS BYTE
	DFB 1,2,3	;ID

	ASC 'TOMIDOS DISK v.0'
	DFB $9B	;EOL

TERR	ASC 'NOT SYSTEM DISK!'
	DFB $9B	;EOL

SK24	LDA SK22
	STA SK9
	LDA SK23
	STA SK10
	LDA #FMSBUF&255
	LDX #FMSBUF>>8
	JSR SK33
	LDA FMSBUF
	STA SK22
	LDA FMSBUF+1
	STA SK23
	LDY #4	;PRVY ZAZNAM
	STY 145
SK25	LDY 145
	CPY SK21
	BEQ SK24
	LDA FMSBUF,Y
	STA SK9
	LDA FMSBUF+1,Y
	STA SK10
	INY
	INY
	STY 145
AIN	RTS

SK26	JMP (SK2)	;INIT.

SK27	LDA STAT
	LSR
	BCC SK31
	LDX #0
	LDA SK21
	STA 145
	STA 144
	STA SK7
	BNE SK28
	INX
SK28	STX SK8
	JSR SK34
	STA 150
	JSR SK34
	AND 150
	CMP #255 ;BIN. SUBOR?
	BNE SK31 ;NIE - ERROR NO DOS
SK29	LDA #AIN&255
	STA SK2
	LDA #AIN>>8
	STA SK3
	JSR SK34
	STA 146
	JSR SK34
	STA 147
	ORA 146
	BEQ SK30 ;UZ NIEJE DALSI BLOK
	JSR SK34
	SEC
	SBC 146
	PHA
	PHP
	JSR SK34
	PLP
	SBC 147
	STA 149
	PLA
	STA 148
	JSR SK41 ;NAHRA CELY BLOK
	JSR SK26 ;INICIALIZACIA (RTS)
	JMP SK29 ;LOAD DALSI BLOK
SK30	JMP (SK1)	;START PROG

SK31	LDA #TERR&255
	LDX #TERR>>8
	STA SK12
	STX SK13
	STX SK14
	LDA #9	;PRINT
	STA SK11
	LDX #0	;#0
	JSR SK48 ;CIO - PRINT ERROR
SK32	JMP SK32 ;WAIT

SK33	LDY #64	;VSTUP
	STY SK4
	STA SK5	;L - BUFER
	STX SK6	;H - BUFER
	LDA SK9
	ORA SK10
	BEQ SK31 ;SEKTOR=0 - ERROR
	JSR SK49 ;SIOINTERFACE
	BMI SK31 ;CYBA 
	RTS

SK34	LDA #0
	STA 149
	STA 148	;DLZ=0
SK35	LDX 144
	CPX SK21 ;DLZ SEK.
	BEQ SK36 ;NAHRAT DALSI SEK.
	LDA DATBUF,X
	INC 144
	RTS
SK36	JSR SK25 ;NAST. 778,9 Z FMS
	LDA 149	;H - DLZ
	BNE SK38 ;AK VIAC AKO 1 SEK.
	LDA SK21 ;DL. SEKTORU
	BEQ SK37
	LDA 148	;L - DLZ
	BMI SK38 ;AK VIAC AKO 1 SEK.
SK37	LDA #DATBUF&255
	LDX #DATBUF>>8
	JSR SK33 ;NAHRA SEK.
	SEC
	ROL 144	;144=1
	LDA DATBUF
	RTS

SK38	LDA 146
	LDX 147
	JSR SK33 ;NAH.SEK.
	LDA 146	;\
	CLC
	ADC SK7
	STA 146	;  ADR=ADR+DL.SEK.
	LDA 147
	ADC SK8
	STA 147	;/
	SEC	;\
	LDA 148
	SBC SK7
	STA 148	;  DLZ=DLZ-DL.SEK.
	LDA 149
	SBC SK8
	STA 149	;/
	JMP SK36 ;CONT. LOAD

SK39	LDA 148
	BNE SK40
	DEC 149
SK40	DEC 148	;DEC DLZ
SK41	JSR SK35 ;NAHRA
	LDY #0
	STA (146),Y
	INC 146
	BNE SK42
	INC 147
SK42	LDA 148
	ORA 149
	BNE SK39 ;ESTE NIEJE KONIEC
	RTS

SK48	EQU 58454
SK49	EQU 58457

